<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for EmployeeSearchRow StructType
 * @subpackage Structs
 */
class EmployeeSearchRow extends SearchRow
{
    /**
     * The basic
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\EmployeeSearchRowBasic
     */
    public $basic;
    /**
     * The campaignResponseJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\CampaignSearchRowBasic
     */
    public $campaignResponseJoin;
    /**
     * The chargeJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\ChargeSearchRowBasic
     */
    public $chargeJoin;
    /**
     * The departmentJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\DepartmentSearchRowBasic
     */
    public $departmentJoin;
    /**
     * The fileJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\FileSearchRowBasic
     */
    public $fileJoin;
    /**
     * The hcmJobJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\HcmJobSearchRowBasic
     */
    public $hcmJobJoin;
    /**
     * The locationJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\LocationSearchRowBasic
     */
    public $locationJoin;
    /**
     * The managedJobJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\JobSearchRowBasic
     */
    public $managedJobJoin;
    /**
     * The messagesJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\MessageSearchRowBasic
     */
    public $messagesJoin;
    /**
     * The messagesFromJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\MessageSearchRowBasic
     */
    public $messagesFromJoin;
    /**
     * The messagesToJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\MessageSearchRowBasic
     */
    public $messagesToJoin;
    /**
     * The resourceAllocationJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\ResourceAllocationSearchRowBasic
     */
    public $resourceAllocationJoin;
    /**
     * The subsidiaryJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\SubsidiarySearchRowBasic
     */
    public $subsidiaryJoin;
    /**
     * The timeJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\TimeBillSearchRowBasic
     */
    public $timeJoin;
    /**
     * The transactionJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\TransactionSearchRowBasic
     */
    public $transactionJoin;
    /**
     * The userJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\EmployeeSearchRowBasic
     */
    public $userJoin;
    /**
     * The userNotesJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\NoteSearchRowBasic
     */
    public $userNotesJoin;
    /**
     * The customSearchJoin
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\CustomSearchRowBasic[]
     */
    public $customSearchJoin;
    /**
     * Constructor method for EmployeeSearchRow
     * @uses EmployeeSearchRow::setBasic()
     * @uses EmployeeSearchRow::setCampaignResponseJoin()
     * @uses EmployeeSearchRow::setChargeJoin()
     * @uses EmployeeSearchRow::setDepartmentJoin()
     * @uses EmployeeSearchRow::setFileJoin()
     * @uses EmployeeSearchRow::setHcmJobJoin()
     * @uses EmployeeSearchRow::setLocationJoin()
     * @uses EmployeeSearchRow::setManagedJobJoin()
     * @uses EmployeeSearchRow::setMessagesJoin()
     * @uses EmployeeSearchRow::setMessagesFromJoin()
     * @uses EmployeeSearchRow::setMessagesToJoin()
     * @uses EmployeeSearchRow::setResourceAllocationJoin()
     * @uses EmployeeSearchRow::setSubsidiaryJoin()
     * @uses EmployeeSearchRow::setTimeJoin()
     * @uses EmployeeSearchRow::setTransactionJoin()
     * @uses EmployeeSearchRow::setUserJoin()
     * @uses EmployeeSearchRow::setUserNotesJoin()
     * @uses EmployeeSearchRow::setCustomSearchJoin()
     * @param \StructType\EmployeeSearchRowBasic $basic
     * @param \StructType\CampaignSearchRowBasic $campaignResponseJoin
     * @param \StructType\ChargeSearchRowBasic $chargeJoin
     * @param \StructType\DepartmentSearchRowBasic $departmentJoin
     * @param \StructType\FileSearchRowBasic $fileJoin
     * @param \StructType\HcmJobSearchRowBasic $hcmJobJoin
     * @param \StructType\LocationSearchRowBasic $locationJoin
     * @param \StructType\JobSearchRowBasic $managedJobJoin
     * @param \StructType\MessageSearchRowBasic $messagesJoin
     * @param \StructType\MessageSearchRowBasic $messagesFromJoin
     * @param \StructType\MessageSearchRowBasic $messagesToJoin
     * @param \StructType\ResourceAllocationSearchRowBasic $resourceAllocationJoin
     * @param \StructType\SubsidiarySearchRowBasic $subsidiaryJoin
     * @param \StructType\TimeBillSearchRowBasic $timeJoin
     * @param \StructType\TransactionSearchRowBasic $transactionJoin
     * @param \StructType\EmployeeSearchRowBasic $userJoin
     * @param \StructType\NoteSearchRowBasic $userNotesJoin
     * @param \StructType\CustomSearchRowBasic[] $customSearchJoin
     */
    public function __construct(\StructType\EmployeeSearchRowBasic $basic = null, \StructType\CampaignSearchRowBasic $campaignResponseJoin = null, \StructType\ChargeSearchRowBasic $chargeJoin = null, \StructType\DepartmentSearchRowBasic $departmentJoin = null, \StructType\FileSearchRowBasic $fileJoin = null, \StructType\HcmJobSearchRowBasic $hcmJobJoin = null, \StructType\LocationSearchRowBasic $locationJoin = null, \StructType\JobSearchRowBasic $managedJobJoin = null, \StructType\MessageSearchRowBasic $messagesJoin = null, \StructType\MessageSearchRowBasic $messagesFromJoin = null, \StructType\MessageSearchRowBasic $messagesToJoin = null, \StructType\ResourceAllocationSearchRowBasic $resourceAllocationJoin = null, \StructType\SubsidiarySearchRowBasic $subsidiaryJoin = null, \StructType\TimeBillSearchRowBasic $timeJoin = null, \StructType\TransactionSearchRowBasic $transactionJoin = null, \StructType\EmployeeSearchRowBasic $userJoin = null, \StructType\NoteSearchRowBasic $userNotesJoin = null, array $customSearchJoin = array())
    {
        $this
            ->setBasic($basic)
            ->setCampaignResponseJoin($campaignResponseJoin)
            ->setChargeJoin($chargeJoin)
            ->setDepartmentJoin($departmentJoin)
            ->setFileJoin($fileJoin)
            ->setHcmJobJoin($hcmJobJoin)
            ->setLocationJoin($locationJoin)
            ->setManagedJobJoin($managedJobJoin)
            ->setMessagesJoin($messagesJoin)
            ->setMessagesFromJoin($messagesFromJoin)
            ->setMessagesToJoin($messagesToJoin)
            ->setResourceAllocationJoin($resourceAllocationJoin)
            ->setSubsidiaryJoin($subsidiaryJoin)
            ->setTimeJoin($timeJoin)
            ->setTransactionJoin($transactionJoin)
            ->setUserJoin($userJoin)
            ->setUserNotesJoin($userNotesJoin)
            ->setCustomSearchJoin($customSearchJoin);
    }
    /**
     * Get basic value
     * @return \StructType\EmployeeSearchRowBasic|null
     */
    public function getBasic()
    {
        return $this->basic;
    }
    /**
     * Set basic value
     * @param \StructType\EmployeeSearchRowBasic $basic
     * @return \StructType\EmployeeSearchRow
     */
    public function setBasic(\StructType\EmployeeSearchRowBasic $basic = null)
    {
        $this->basic = $basic;
        return $this;
    }
    /**
     * Get campaignResponseJoin value
     * @return \StructType\CampaignSearchRowBasic|null
     */
    public function getCampaignResponseJoin()
    {
        return $this->campaignResponseJoin;
    }
    /**
     * Set campaignResponseJoin value
     * @param \StructType\CampaignSearchRowBasic $campaignResponseJoin
     * @return \StructType\EmployeeSearchRow
     */
    public function setCampaignResponseJoin(\StructType\CampaignSearchRowBasic $campaignResponseJoin = null)
    {
        $this->campaignResponseJoin = $campaignResponseJoin;
        return $this;
    }
    /**
     * Get chargeJoin value
     * @return \StructType\ChargeSearchRowBasic|null
     */
    public function getChargeJoin()
    {
        return $this->chargeJoin;
    }
    /**
     * Set chargeJoin value
     * @param \StructType\ChargeSearchRowBasic $chargeJoin
     * @return \StructType\EmployeeSearchRow
     */
    public function setChargeJoin(\StructType\ChargeSearchRowBasic $chargeJoin = null)
    {
        $this->chargeJoin = $chargeJoin;
        return $this;
    }
    /**
     * Get departmentJoin value
     * @return \StructType\DepartmentSearchRowBasic|null
     */
    public function getDepartmentJoin()
    {
        return $this->departmentJoin;
    }
    /**
     * Set departmentJoin value
     * @param \StructType\DepartmentSearchRowBasic $departmentJoin
     * @return \StructType\EmployeeSearchRow
     */
    public function setDepartmentJoin(\StructType\DepartmentSearchRowBasic $departmentJoin = null)
    {
        $this->departmentJoin = $departmentJoin;
        return $this;
    }
    /**
     * Get fileJoin value
     * @return \StructType\FileSearchRowBasic|null
     */
    public function getFileJoin()
    {
        return $this->fileJoin;
    }
    /**
     * Set fileJoin value
     * @param \StructType\FileSearchRowBasic $fileJoin
     * @return \StructType\EmployeeSearchRow
     */
    public function setFileJoin(\StructType\FileSearchRowBasic $fileJoin = null)
    {
        $this->fileJoin = $fileJoin;
        return $this;
    }
    /**
     * Get hcmJobJoin value
     * @return \StructType\HcmJobSearchRowBasic|null
     */
    public function getHcmJobJoin()
    {
        return $this->hcmJobJoin;
    }
    /**
     * Set hcmJobJoin value
     * @param \StructType\HcmJobSearchRowBasic $hcmJobJoin
     * @return \StructType\EmployeeSearchRow
     */
    public function setHcmJobJoin(\StructType\HcmJobSearchRowBasic $hcmJobJoin = null)
    {
        $this->hcmJobJoin = $hcmJobJoin;
        return $this;
    }
    /**
     * Get locationJoin value
     * @return \StructType\LocationSearchRowBasic|null
     */
    public function getLocationJoin()
    {
        return $this->locationJoin;
    }
    /**
     * Set locationJoin value
     * @param \StructType\LocationSearchRowBasic $locationJoin
     * @return \StructType\EmployeeSearchRow
     */
    public function setLocationJoin(\StructType\LocationSearchRowBasic $locationJoin = null)
    {
        $this->locationJoin = $locationJoin;
        return $this;
    }
    /**
     * Get managedJobJoin value
     * @return \StructType\JobSearchRowBasic|null
     */
    public function getManagedJobJoin()
    {
        return $this->managedJobJoin;
    }
    /**
     * Set managedJobJoin value
     * @param \StructType\JobSearchRowBasic $managedJobJoin
     * @return \StructType\EmployeeSearchRow
     */
    public function setManagedJobJoin(\StructType\JobSearchRowBasic $managedJobJoin = null)
    {
        $this->managedJobJoin = $managedJobJoin;
        return $this;
    }
    /**
     * Get messagesJoin value
     * @return \StructType\MessageSearchRowBasic|null
     */
    public function getMessagesJoin()
    {
        return $this->messagesJoin;
    }
    /**
     * Set messagesJoin value
     * @param \StructType\MessageSearchRowBasic $messagesJoin
     * @return \StructType\EmployeeSearchRow
     */
    public function setMessagesJoin(\StructType\MessageSearchRowBasic $messagesJoin = null)
    {
        $this->messagesJoin = $messagesJoin;
        return $this;
    }
    /**
     * Get messagesFromJoin value
     * @return \StructType\MessageSearchRowBasic|null
     */
    public function getMessagesFromJoin()
    {
        return $this->messagesFromJoin;
    }
    /**
     * Set messagesFromJoin value
     * @param \StructType\MessageSearchRowBasic $messagesFromJoin
     * @return \StructType\EmployeeSearchRow
     */
    public function setMessagesFromJoin(\StructType\MessageSearchRowBasic $messagesFromJoin = null)
    {
        $this->messagesFromJoin = $messagesFromJoin;
        return $this;
    }
    /**
     * Get messagesToJoin value
     * @return \StructType\MessageSearchRowBasic|null
     */
    public function getMessagesToJoin()
    {
        return $this->messagesToJoin;
    }
    /**
     * Set messagesToJoin value
     * @param \StructType\MessageSearchRowBasic $messagesToJoin
     * @return \StructType\EmployeeSearchRow
     */
    public function setMessagesToJoin(\StructType\MessageSearchRowBasic $messagesToJoin = null)
    {
        $this->messagesToJoin = $messagesToJoin;
        return $this;
    }
    /**
     * Get resourceAllocationJoin value
     * @return \StructType\ResourceAllocationSearchRowBasic|null
     */
    public function getResourceAllocationJoin()
    {
        return $this->resourceAllocationJoin;
    }
    /**
     * Set resourceAllocationJoin value
     * @param \StructType\ResourceAllocationSearchRowBasic $resourceAllocationJoin
     * @return \StructType\EmployeeSearchRow
     */
    public function setResourceAllocationJoin(\StructType\ResourceAllocationSearchRowBasic $resourceAllocationJoin = null)
    {
        $this->resourceAllocationJoin = $resourceAllocationJoin;
        return $this;
    }
    /**
     * Get subsidiaryJoin value
     * @return \StructType\SubsidiarySearchRowBasic|null
     */
    public function getSubsidiaryJoin()
    {
        return $this->subsidiaryJoin;
    }
    /**
     * Set subsidiaryJoin value
     * @param \StructType\SubsidiarySearchRowBasic $subsidiaryJoin
     * @return \StructType\EmployeeSearchRow
     */
    public function setSubsidiaryJoin(\StructType\SubsidiarySearchRowBasic $subsidiaryJoin = null)
    {
        $this->subsidiaryJoin = $subsidiaryJoin;
        return $this;
    }
    /**
     * Get timeJoin value
     * @return \StructType\TimeBillSearchRowBasic|null
     */
    public function getTimeJoin()
    {
        return $this->timeJoin;
    }
    /**
     * Set timeJoin value
     * @param \StructType\TimeBillSearchRowBasic $timeJoin
     * @return \StructType\EmployeeSearchRow
     */
    public function setTimeJoin(\StructType\TimeBillSearchRowBasic $timeJoin = null)
    {
        $this->timeJoin = $timeJoin;
        return $this;
    }
    /**
     * Get transactionJoin value
     * @return \StructType\TransactionSearchRowBasic|null
     */
    public function getTransactionJoin()
    {
        return $this->transactionJoin;
    }
    /**
     * Set transactionJoin value
     * @param \StructType\TransactionSearchRowBasic $transactionJoin
     * @return \StructType\EmployeeSearchRow
     */
    public function setTransactionJoin(\StructType\TransactionSearchRowBasic $transactionJoin = null)
    {
        $this->transactionJoin = $transactionJoin;
        return $this;
    }
    /**
     * Get userJoin value
     * @return \StructType\EmployeeSearchRowBasic|null
     */
    public function getUserJoin()
    {
        return $this->userJoin;
    }
    /**
     * Set userJoin value
     * @param \StructType\EmployeeSearchRowBasic $userJoin
     * @return \StructType\EmployeeSearchRow
     */
    public function setUserJoin(\StructType\EmployeeSearchRowBasic $userJoin = null)
    {
        $this->userJoin = $userJoin;
        return $this;
    }
    /**
     * Get userNotesJoin value
     * @return \StructType\NoteSearchRowBasic|null
     */
    public function getUserNotesJoin()
    {
        return $this->userNotesJoin;
    }
    /**
     * Set userNotesJoin value
     * @param \StructType\NoteSearchRowBasic $userNotesJoin
     * @return \StructType\EmployeeSearchRow
     */
    public function setUserNotesJoin(\StructType\NoteSearchRowBasic $userNotesJoin = null)
    {
        $this->userNotesJoin = $userNotesJoin;
        return $this;
    }
    /**
     * Get customSearchJoin value
     * @return \StructType\CustomSearchRowBasic[]|null
     */
    public function getCustomSearchJoin()
    {
        return $this->customSearchJoin;
    }
    /**
     * This method is responsible for validating the values passed to the setCustomSearchJoin method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCustomSearchJoin method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCustomSearchJoinForArrayConstraintsFromSetCustomSearchJoin(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $employeeSearchRowCustomSearchJoinItem) {
            // validation for constraint: itemType
            if (!$employeeSearchRowCustomSearchJoinItem instanceof \StructType\CustomSearchRowBasic) {
                $invalidValues[] = is_object($employeeSearchRowCustomSearchJoinItem) ? get_class($employeeSearchRowCustomSearchJoinItem) : sprintf('%s(%s)', gettype($employeeSearchRowCustomSearchJoinItem), var_export($employeeSearchRowCustomSearchJoinItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The customSearchJoin property can only contain items of type \StructType\CustomSearchRowBasic, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set customSearchJoin value
     * @throws \InvalidArgumentException
     * @param \StructType\CustomSearchRowBasic[] $customSearchJoin
     * @return \StructType\EmployeeSearchRow
     */
    public function setCustomSearchJoin(array $customSearchJoin = array())
    {
        // validation for constraint: array
        if ('' !== ($customSearchJoinArrayErrorMessage = self::validateCustomSearchJoinForArrayConstraintsFromSetCustomSearchJoin($customSearchJoin))) {
            throw new \InvalidArgumentException($customSearchJoinArrayErrorMessage, __LINE__);
        }
        $this->customSearchJoin = $customSearchJoin;
        return $this;
    }
    /**
     * Add item to customSearchJoin value
     * @throws \InvalidArgumentException
     * @param \StructType\CustomSearchRowBasic $item
     * @return \StructType\EmployeeSearchRow
     */
    public function addToCustomSearchJoin(\StructType\CustomSearchRowBasic $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CustomSearchRowBasic) {
            throw new \InvalidArgumentException(sprintf('The customSearchJoin property can only contain items of type \StructType\CustomSearchRowBasic, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->customSearchJoin[] = $item;
        return $this;
    }
}
